// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use crate::{ffi, Language, LanguageInfo};
use glib::translate::*;

glib::wrapper! {
    #[doc(alias = "SpellingProvider")]
    pub struct Provider(Object<ffi::SpellingProvider, ffi::SpellingProviderClass>);

    match fn {
        type_ => || ffi::spelling_provider_get_type(),
    }
}

impl Provider {
    #[doc(alias = "spelling_provider_get_default_code")]
    #[doc(alias = "get_default_code")]
    pub fn default_code(&self) -> glib::GString {
        unsafe {
            from_glib_none(ffi::spelling_provider_get_default_code(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spelling_provider_get_display_name")]
    #[doc(alias = "get_display_name")]
    #[doc(alias = "display-name")]
    pub fn display_name(&self) -> glib::GString {
        unsafe {
            from_glib_none(ffi::spelling_provider_get_display_name(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spelling_provider_get_language")]
    #[doc(alias = "get_language")]
    pub fn language(&self, language: &str) -> Option<Language> {
        unsafe {
            from_glib_full(ffi::spelling_provider_get_language(
                self.to_glib_none().0,
                language.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spelling_provider_list_languages")]
    pub fn list_languages(&self) -> Vec<LanguageInfo> {
        unsafe {
            FromGlibPtrContainer::from_glib_container(ffi::spelling_provider_list_languages(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spelling_provider_supports_language")]
    pub fn supports_language(&self, language: &str) -> bool {
        unsafe {
            from_glib(ffi::spelling_provider_supports_language(
                self.to_glib_none().0,
                language.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spelling_provider_get_default")]
    #[doc(alias = "get_default")]
    #[allow(clippy::should_implement_trait)]
    pub fn default() -> Provider {
        assert_initialized_main_thread!();
        unsafe { from_glib_none(ffi::spelling_provider_get_default()) }
    }
}
